package gregapi;

import static gregapi.data.CS.*;
import enviromine.EnviroPotion;
import gregapi.api.Abstract_Mod;
import gregapi.api.Abstract_Proxy;
import gregapi.block.prefixblock.PrefixBlockFallingEntity;
import gregapi.block.prefixblock.PrefixBlockTileEntity;
import gregapi.code.ArrayListNoNulls;
import gregapi.code.HashSetNoNulls;
import gregapi.code.ItemStackContainer;
import gregapi.compat.CompatBase;
import gregapi.compat.buildcraft.ICompatBC;
import gregapi.compat.computercraft.ICompatCC;
import gregapi.compat.industrialcraft.ICompatIC2;
import gregapi.compat.opencomputers.ICompatOC;
import gregapi.compat.thaumcraft.ICompatTC;
import gregapi.config.Config;
import gregapi.data.*;
import gregapi.data.CS.ConfigsGT;
import gregapi.data.CS.DirectoriesGT;
import gregapi.data.CS.IconsGT;
import gregapi.data.CS.ModIDs;
import gregapi.data.CS.ModNames;
import gregapi.data.CS.PotionsGT;
import gregapi.dummies.DummyWorld;
import gregapi.enchants.Enchantment_EnderDamage;
import gregapi.enchants.Enchantment_Radioactivity;
import gregapi.enchants.Enchantment_SlimeDamage;
import gregapi.enchants.Enchantment_WerewolfDamage;
import gregapi.item.ItemFluidDisplay;
import gregapi.item.ItemIntegratedCircuit;
import gregapi.lang.LanguageHandler;
import gregapi.load.LoaderOreDictReRegistrations;
import gregapi.log.LogBuffer;
import gregapi.log.LoggerPlayerActivity;
import gregapi.network.NetworkHandler;
import gregapi.network.packets.*;
import gregapi.network.packets.covers.*;
import gregapi.network.packets.covervisuals.*;
import gregapi.network.packets.data.*;
import gregapi.network.packets.ids.*;
import gregapi.oredict.OreDictManager;
import gregapi.oredict.OreDictMaterial;
import gregapi.oredict.OreDictPrefix;
import gregapi.recipes.AdvancedCraftingShaped;
import gregapi.recipes.AdvancedCraftingShapeless;
import gregapi.recipes.GT_ModHandler;
import gregapi.recipes.Recipe;
import gregapi.render.ITexture;
import gregapi.render.TextureSet;
import gregapi.tileentity.energy.EnergyCompat;
import gregapi.util.OM;
import gregapi.util.UT;

import java.io.File;
import java.io.PrintStream;
import java.util.*;

import net.minecraft.client.renderer.texture.IIconRegister;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.CraftingManager;
import net.minecraft.item.crafting.FurnaceRecipes;
import net.minecraft.item.crafting.IRecipe;
import net.minecraft.util.WeightedRandomChestContent;
import net.minecraftforge.common.ChestGenHooks;
import net.minecraftforge.common.config.Configuration;
import net.minecraftforge.oredict.RecipeSorter;
import net.minecraftforge.oredict.ShapedOreRecipe;
import net.minecraftforge.oredict.ShapelessOreRecipe;
import cpw.mods.fml.common.FMLLog;
import cpw.mods.fml.common.Loader;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.SidedProxy;
import cpw.mods.fml.common.event.*;
import cpw.mods.fml.common.network.NetworkRegistry;
import cpw.mods.fml.common.registry.EntityRegistry;
import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

/**
 * @author Gregorius Techneticies
 * 
 * This loads before the compatible Mods. GT_API_Post loads after the compatible Mods.
 */
@Mod(modid=ModIDs.GAPI, name=ModNames.GAPI, version="GT6-MC1710", dependencies="required-before:"+ModIDs.GAPI_POST+"; before:"+ModIDs.IC2+"; before:"+ModIDs.NC+"; before:"+ModIDs.FMB+"; before:"+ModIDs.CrGu+"; before:"+ModIDs.CC+"; before:"+ModIDs.OC+"; before:"+ModIDs.FR+"; before:"+ModIDs.IE+"; before:"+ModIDs.UB+"; before:"+ModIDs.PFAA+"; before:"+ModIDs.TC+"; before:"+ModIDs.TCFM+"; before:"+ModIDs.BOTA+"; before:"+ModIDs.WTCH+"; before:"+ModIDs.HOWL+"; before:"+ModIDs.MoCr+"; before:"+ModIDs.RC+"; before:"+ModIDs.AE+"; before:"+ModIDs.TE_CORE+"; before:"+ModIDs.TE+"; before:"+ModIDs.CHSL+"; before:"+ModIDs.BbLC+"; before:"+ModIDs.TF+"; before:"+ModIDs.MFR+"; before:"+ModIDs.ExU+"; before:"+ModIDs.HaC+"; before:"+ModIDs.APC+"; before:"+ModIDs.ENVM+"; before:"+ModIDs.MaCr+"; before:"+ModIDs.BC_TRANSPORT+"; before:"+ModIDs.BC_SILICON+"; before:"+ModIDs.BC_FACTORY+"; before:"+ModIDs.BC_ENERGY+"; before:"+ModIDs.BC_ROBOTICS+"; before:"+ModIDs.BC_CORE+"; before:"+ModIDs.BC_BUILDERS+"; before:"+ModIDs.MgC+"; before:"+ModIDs.DRGN+"; before:"+ModIDs.ElC+"; before:"+ModIDs.CrC+"; before:"+ModIDs.ReC+"; before:"+ModIDs.RoC+"; before:"+ModIDs.GC_CORE+"; before:"+ModIDs.GC_MARS+"; before:"+ModIDs.GC_PLANETS+"; before:"+ModIDs.ATUM+"; before:"+ModIDs.EBXL+"; before:"+ModIDs.BoP+"; before:"+ModIDs.ATG+"; before:"+ModIDs.MYST+"; before:"+ModIDs.ENCHIRIDION+"; before:"+ModIDs.ENCHIRIDION2+"; before:"+ModIDs.SmAc+"; before:"+ModIDs.HQM+"; before:"+ModIDs.JABBA+"; before:"+ModIDs.FZ+"; before:"+ModIDs.MNTL+"; before:"+ModIDs.TiC+";")
public class GT_API extends Abstract_Mod {
    @SidedProxy(modId = ModIDs.GAPI, clientSide = "gregapi.GT_API_Proxy_Client", serverSide = "gregapi.GT_API_Proxy_Server")
    public static GT_API_Proxy api_proxy;
	
	public static final Collection<Map<ItemStackContainer, ?>> STACKMAPS = new ArrayListNoNulls<Map<ItemStackContainer, ?>>();
	
	public static boolean sAllowCrossModItemAccess = F;
	
	/** Used to register Icons. It is not necessary to make those into Lists */
	public static Set<Runnable> sBlockIconload = new HashSetNoNulls<Runnable>(), sItemIconload = new HashSetNoNulls<Runnable>();
	/** The Icon Registers from Blocks and Items. They will get set right before the corresponding Icon Load Phase as executed in the Runnable List above. */
	@SideOnly(Side.CLIENT)
	public static IIconRegister sBlockIcons, sItemIcons;
	
	/** Used to register IC2 Stuff, this Object might be null if IC2 isn't installed. */
	public static ICompatIC2	sCompatIC2;
	/** Used to register Aspects to ThaumCraft, this Object might be null if ThaumCraft isn't installed. */
	public static ICompatTC		sCompatTC;
	/** Used to register BuildCraft Stuff, this Object might be null if BuildCraft isn't installed. */
	public static ICompatBC		sCompatBC;
	/** Used to register ComputerCraft Stuff, this Object might be null if ComputerCraft isn't installed. */
	public static ICompatCC		sCompatCC;
	/** Used to register OpenComputers Stuff, this Object might be null if OpenComputers isn't installed. */
	public static ICompatOC		sCompatOC;
	
	private LoggerPlayerActivity mPlayerLogger;
	
	public GT_API() {
		GAPI = this;
		
		// A bunch of Code that is there to statically initialise the Database in the right order.
		BI.BAROMETER.toString();
		MT.NULL.toString();
		AM.Hydrogen.toString();
		OP.ore.toString();
		
		DW = new DummyWorld();
		
		IconsGT.INDEX_BLOCK_MOLTEN		= TextureSet.addToAll(ModIDs.GT, F, "molten");
		IconsGT.INDEX_BLOCK_PIPE_SIDE	= TextureSet.addToAll(ModIDs.GT, F, "pipeSide");
		
		OP.pipeTiny		.addTextureSet(ModIDs.GT, F);
		OP.pipeSmall	.addTextureSet(ModIDs.GT, F);
		OP.pipeMedium	.addTextureSet(ModIDs.GT, F);
		OP.pipeLarge	.addTextureSet(ModIDs.GT, F);
		OP.pipeHuge		.addTextureSet(ModIDs.GT, F);
		
		OP.wire			.addTextureSet(ModIDs.GT, F);
		OP.foil			.addTextureSet(ModIDs.GT, F);
		
		// It is VERY important that those are registered first. Otherwise GregTech would output its own Storage Blocks.
        OreDictManager.INSTANCE.setTarget_(OP.blockSolid		, MT.Obsidian			, UT.Stacks.make(Blocks.obsidian, 1, 0));
        OreDictManager.INSTANCE.setTarget_(OP.blockIngot		, MT.Fe					, UT.Stacks.make(Blocks.iron_block, 1, 0));
        OreDictManager.INSTANCE.setTarget_(OP.blockIngot		, MT.Au					, UT.Stacks.make(Blocks.gold_block, 1, 0));
        OreDictManager.INSTANCE.setTarget_(OP.blockGem			, MT.Diamond			, UT.Stacks.make(Blocks.diamond_block, 1, 0));
        OreDictManager.INSTANCE.setTarget_(OP.blockGem			, MT.Emerald			, UT.Stacks.make(Blocks.emerald_block, 1, 0));
        OreDictManager.INSTANCE.setTarget_(OP.blockGem			, MT.Lapis				, UT.Stacks.make(Blocks.lapis_block, 1, 0));
        OreDictManager.INSTANCE.setTarget_(OP.blockGem			, MT.Coal				, UT.Stacks.make(Blocks.coal_block, 1, 0));
        OreDictManager.INSTANCE.setTarget_(OP.blockDust			, MT.Redstone			, UT.Stacks.make(Blocks.redstone_block, 1, 0));
        
        Items.mushroom_stew.setContainerItem(Items.bowl);
        Items.potionitem.setContainerItem(Items.glass_bottle);
        Items.experience_bottle.setContainerItem(Items.glass_bottle);
	}
    
	@Mod.EventHandler
    public void onPreLoad(FMLPreInitializationEvent aEvent) {
		DirectoriesGT.CONFIG = aEvent.getModConfigurationDirectory();
		DirectoriesGT.CONFIG_GT = new File(DirectoriesGT.CONFIG, "GregTech");
		DirectoriesGT.CONFIG_RECIPES = new File(DirectoriesGT.CONFIG, "Recipes");
		DirectoriesGT.MINECRAFT = DirectoriesGT.CONFIG.getParentFile();
		DirectoriesGT.LOGS = new File(DirectoriesGT.MINECRAFT, "logs");
		
		onModPreInit(aEvent);
    }
    
	@Mod.EventHandler
    public void onLoad(FMLInitializationEvent aEvent) {
		for (OreDictMaterial tMaterial : OreDictMaterial.MATERIAL_ARRAY) if (tMaterial != null) {
			tMaterial.mToolQuality = (byte)ConfigsGT.MATERIAL.get(tMaterial.mNameInternal, "ToolQuality", tMaterial.mToolQuality);
			if (tMaterial.contains(TD.Properties.HAS_TOOL_STATS)) {
				tMaterial.mToolSpeed = (float)ConfigsGT.MATERIAL.get(tMaterial.mNameInternal, "ToolSpeed", tMaterial.mToolSpeed);
				tMaterial.mToolDurability = ConfigsGT.MATERIAL.get(tMaterial.mNameInternal, "ToolDurability", tMaterial.mToolDurability);
				tMaterial.mHandleMaterial = OreDictMaterial.get(ConfigsGT.MATERIAL.get(tMaterial.mNameInternal, "ToolHandle", tMaterial.mHandleMaterial.mNameInternal));
			}
		}
		
		onModInit(aEvent);
	}
	
//  @SubscribeEvent
//  @Mod.EventHandler
//  public void loadComplete(FMLLoadCompleteEvent aEvent) {
//		Why the fuck doesn't this work!?! Who can actually receive this Event? Both annotations won't work...
//  }
	
	@Override public String getModID() {return ModIDs.GAPI;}
	@Override public String getModName() {return ModNames.GAPI;}
	@Override public String getModNameForLog() {return "GT_API";}
	@Override public Abstract_Proxy getProxy() {return api_proxy;}
	
	@Mod.EventHandler public void onPostLoad		(FMLPostInitializationEvent	aEvent) {onModPostInit(aEvent);}
	@Mod.EventHandler public void onServerStarting	(FMLServerStartingEvent		aEvent) {onModServerStarting(aEvent);}
	@Mod.EventHandler public void onServerStarted	(FMLServerStartedEvent		aEvent) {onModServerStarted(aEvent);}
	@Mod.EventHandler public void onServerStopping	(FMLServerStoppingEvent		aEvent) {onModServerStopping(aEvent);}
	@Mod.EventHandler public void onServerStopped	(FMLServerStoppedEvent		aEvent) {onModServerStopped(aEvent);}
	
	@Mod.EventHandler
	public void onIDChangingEvent(FMLModIdMappingEvent aEvent) {
        OUT.println(getModNameForLog() + ": Re-Unificating Recipes.");
//    	UT.Fluids.reInit();
    	Recipe.reInit();
    	
		for (Map tMap : STACKMAPS) UT.Code.reMap(tMap);
		
		for (CompatBase tCompat : CompatBase.COMPAT_CLASSES) try {tCompat.onIDChanging(aEvent);} catch(Throwable e) {if (D1) e.printStackTrace(ERR);}
	}
	
	@Override
	public void onModPreInit2(FMLPreInitializationEvent aEvent) {
    	Config.sConfigFileIDs = new Configuration(new File(DirectoriesGT.CONFIG_GT, "IDs.cfg")); Config.sConfigFileIDs.save();
    	Configuration tMainConfig = new Configuration(new File(DirectoriesGT.CONFIG_GT, "GregTech.cfg"));
    	Configuration tStackConfig = new Configuration(new File(DirectoriesGT.CONFIG_GT, "Stacksizes.cfg"));
    	
    	File tLogFile = new File(DirectoriesGT.LOGS, "GregTech.log");
    	if (!tLogFile.exists()) try {tLogFile.createNewFile();} catch(Throwable e) {/*Do nothing*/}
		
    	List<String>
		tList1 = ((LogBuffer)ERR).mBufferedLog, tList2 = ((LogBuffer)OUT).mBufferedLog;
    	try {
    		ERR = OUT = new PrintStream(tLogFile);
    	} catch (Throwable e) {
    		ERR = System.err;
    		OUT = System.out;
    	}
    	
		for (String tString : tList1) ERR.println(tString);
		for (String tString : tList2) OUT.println(tString);
		
		File tMaterialListFile = new File(DirectoriesGT.CONFIG_GT, "MaterialList.log");
    	if (!tMaterialListFile.exists()) {try {tMaterialListFile.createNewFile();} catch (Throwable e) {/*Do nothing*/}}
    	
    	if (tMainConfig.get("general", "LoggingPlayerActivity", T).getBoolean(T)) {
    		File tFile = new File(DirectoriesGT.LOGS, "PlayerActivity.log");
        	if (!tFile.exists()) {try {tFile.createNewFile();} catch (Throwable e) {/*Do nothing*/}}
    		try {mPlayerLogger = new LoggerPlayerActivity(new PrintStream(tFile));} catch (Throwable e) {/*Do nothing*/}
    	}
    	
		File tOreDictLogFile = new File(DirectoriesGT.LOGS, "OreDict.log");
    	if (!tOreDictLogFile.exists()) {try {tOreDictLogFile.createNewFile();} catch (Throwable e) {/*Do nothing*/}}
    	
		try {
			tList1 = ((LogBuffer)ORD).mBufferedLog;
    		ORD = new PrintStream(tOreDictLogFile);
    		ORD.println("**********************************************************************");
    		ORD.println("* This is the complete Log of the GregTech OreDictionary Handler     *");/*
    		ORD.println("* Everything in the OreDict goes through it sometimes causing Errors *");
    		ORD.println("* These Errors are getting logged aswell as properly registered Ores *");
    		ORD.println("* If you see something fishy going on in this Log, such as improper  *");
    		ORD.println("* Items being registered, then mention it to the corresponding Mod   *");
    		ORD.println("* In case it mentions GregTech itself improperly registering Stuff   *");
    		ORD.println("* then please contact me about that immediatly                       *");
    		ORD.println("*                                                                    *");
    		ORD.println("* In case of something being 'ignored properly', that one isnt a Bug *");*/
    		ORD.println("**********************************************************************");
    		for (String tString : tList1) ORD.println(tString);
		} catch (Throwable e) {/*Do nothing*/}
		
		try {
    		MAT_LOG = new PrintStream(tMaterialListFile);
    		MAT_LOG.println("**********************************************************************");
    		MAT_LOG.println("* This is the complete List of usable GregTech Materials             *");
    		MAT_LOG.println("**********************************************************************");
		} catch (Throwable e) {/*Do nothing*/}
		
    	D1 = tMainConfig.get("general", "Debug1", F).getBoolean(F);
    	D2 = tMainConfig.get("general", "Debug2", F).getBoolean(F);
    	D3 = tMainConfig.get("general", "Debug3", F).getBoolean(F);
    	
    	if (D1) {
    		tList1 = ((LogBuffer)DEB).mBufferedLog;
        	DEB = OUT;
    		for (String tString : tList1) DEB.println(tString);
    	}
    	
    	for (OreDictPrefix tPrefix : OreDictPrefix.VALUES) if (!tPrefix.contains(TD.Prefix.PREFIX_UNUSED)) {
    		int tDefault = tMainConfig.get("stacksizes", tPrefix.mNameInternal+"_"+tPrefix.mDefaultStackSize, tPrefix.mDefaultStackSize).getInt();
    		tPrefix.setConfigStacksize(tStackConfig.get("stacksizes", tPrefix.mNameInternal+"_"+tDefault, tDefault).getInt());
    	}
    	
    	tMainConfig.removeCategory(tMainConfig.getCategory("stacksizes"));
    	
    	SHOW_HIDDEN_ITEMS					= tMainConfig.get("general", "ShowHiddenItems"				, F).getBoolean(F);
    	SHOW_HIDDEN_MATERIALS				= tMainConfig.get("general", "ShowHiddenMaterials"			, F).getBoolean(F);
    	SHOW_HIDDEN_PREFIXES				= tMainConfig.get("general", "ShowHiddenPrefixes"			, F).getBoolean(F);
    	SHOW_ORE_BLOCK_PREFIXES				= tMainConfig.get("general", "ShowOreBlockPrefixes"			, F).getBoolean(F);
    	SURVIVAL_INTO_ADVENTURE_MODE		= tMainConfig.get("general", "forceAdventureMode"			, F).getBoolean(F);
    	ADVENTURE_MODE_AXE					= tMainConfig.get("general", "AdventureModeStartingAxe"		, T).getBoolean(T);
    	HUNGER_BY_INVENTORY_WEIGT			= tMainConfig.get("general", "AFK_Hunger"					, F).getBoolean(F);
    	INVENTORY_UNIFICATION				= tMainConfig.get("general", "InventoryUnification"			, T).getBoolean(T);
    	CONFIG_HARDNESS_MULTIPLIER_SAND		= tMainConfig.get("general", "HardnessMultiplier_Sand"		, 1.0).getDouble(1.0);
    	CONFIG_HARDNESS_MULTIPLIER_ROCK		= tMainConfig.get("general", "HardnessMultiplier_Rock"		, 1.0).getDouble(1.0);
    	CONFIG_HARDNESS_MULTIPLIER_ORES		= tMainConfig.get("general", "HardnessMultiplier_Ores"		, 1.0).getDouble(1.0);
    	DRINKS_ALWAYS_DRINKABLE				= tMainConfig.get("general", "drinks_always_drinkable"		, F).getBoolean(F);
    	NERFED_WOOD							= tMainConfig.get("general", "WoodNeedsSawForCrafting"		, T).getBoolean(T);
    	UT.Sounds.MULTITHREADED				= tMainConfig.get("general", "sound_multi_threading"		, F).getBoolean(F);
    	
    	if (tMainConfig.get("general", "disable_STDOUT"				, F).getBoolean(F)) System.out.close();
    	if (tMainConfig.get("general", "disable_STDERR"				, F).getBoolean(F)) System.err.close();
    	if (tMainConfig.get("general", "hardermobspawners"			, T).getBoolean(T)) Blocks.mob_spawner.setHardness(500.0F);
    	if (tMainConfig.get("general", "blastresistantmobspawners"	, T).getBoolean(T)) Blocks.mob_spawner.setResistance(6000000.0F);
    	
    	FIRE_EXPLOSIONS						= tMainConfig.get("machines", "explosions_by_fire"			, T).getBoolean(F);
    	RAIN_EXPLOSIONS						= tMainConfig.get("machines", "explosions_by_rain"			, T).getBoolean(F);
    	WATER_EXPLOSIONS					= tMainConfig.get("machines", "explosions_by_water"			, T).getBoolean(F);
    	THUNDER_EXPLOSIONS					= tMainConfig.get("machines", "explosions_by_thunder"		, T).getBoolean(F);
    	OVERCHARGE_EXPLOSIONS				= tMainConfig.get("machines", "explosions_by_overload"		, T).getBoolean(F);
    	
    	// TODO: Currently defaulting to false, change that later
    	FIRE_EXPLOSIONS						= F;
    	RAIN_EXPLOSIONS						= F;
    	WATER_EXPLOSIONS					= F;
    	THUNDER_EXPLOSIONS					= F;
    	OVERCHARGE_EXPLOSIONS				= F;
    	
    	if (CONFIG_HARDNESS_MULTIPLIER_SAND <= 0.0) CONFIG_HARDNESS_MULTIPLIER_SAND = 1.0;
    	if (CONFIG_HARDNESS_MULTIPLIER_ROCK <= 0.0) CONFIG_HARDNESS_MULTIPLIER_ROCK = 1.0;
    	if (CONFIG_HARDNESS_MULTIPLIER_ORES <= 0.0) CONFIG_HARDNESS_MULTIPLIER_ORES = 1.0;
    	
    	HARDNESS_MULTIPLIER_SAND = CONFIG_HARDNESS_MULTIPLIER_SAND;
    	HARDNESS_MULTIPLIER_ROCK = CONFIG_HARDNESS_MULTIPLIER_ROCK;
    	HARDNESS_MULTIPLIER_ORES = CONFIG_HARDNESS_MULTIPLIER_ORES;
    	
    	if (tMainConfig.get("compat", "IndustrialCraft2"	, T).getBoolean(T)) sCompatIC2	= (ICompatIC2	)UT.Reflection.callConstructor("gregapi.compat.industrialcraft.CompatIC2", 0, null, D2);
    	if (tMainConfig.get("compat", "ThaumCraft"			, T).getBoolean(T)) sCompatTC	= (ICompatTC	)UT.Reflection.callConstructor("gregapi.compat.thaumcraft.CompatTC", 0, null, D2);
    	if (tMainConfig.get("compat", "BuildCraft"			, T).getBoolean(T)) sCompatBC	= (ICompatBC	)UT.Reflection.callConstructor("gregapi.compat.buildcraft.CompatBC", 0, null, D2);
    	if (tMainConfig.get("compat", "ComputerCraft"		, T).getBoolean(T)) sCompatCC	= (ICompatCC	)UT.Reflection.callConstructor("gregapi.compat.computercraft.CompatCC", 0, null, D2);
    	if (tMainConfig.get("compat", "OpenComputers"		, T).getBoolean(T)) sCompatOC	= (ICompatOC	)UT.Reflection.callConstructor("gregapi.compat.opencomputers.CompatOC", 0, null, D2);
    	
    	tMainConfig.save();
    	tStackConfig.save();
    	
    	ConfigsGT.CLIENT 					= new Config(DirectoriesGT.MINECRAFT, "GregTech.cfg");
    	
    	ITexture.Util.GT_ALPHA_BLENDING = ConfigsGT.CLIENT.get("general", "useGTAlphaBlending", ITexture.Util.GT_ALPHA_BLENDING);
    	ITexture.Util.MC_ALPHA_BLENDING = ConfigsGT.CLIENT.get("general", "useMCAlphaBlending", ITexture.Util.MC_ALPHA_BLENDING);
    	
    	ConfigsGT.SPECIAL					= new Config("Other.cfg");
    	ConfigsGT.RECIPES					= new Config("Recipes.cfg");
    	ConfigsGT.MACHINES					= new Config("Machines.cfg");
    	ConfigsGT.WORLDGEN					= new Config("WorldGeneration.cfg");
    	ConfigsGT.MATERIAL					= new Config("Materials.cfg");
    	ConfigsGT.OVERPOWERED				= new Config("Overpowered.cfg");
    	ConfigsGT.OREPROCESSING				= new Config("OreProcessing.cfg");
    	
    	// Register Crafting Recipe Classes.
        RecipeSorter.register("gregtech:shaped"			, AdvancedCraftingShaped.class				, net.minecraftforge.oredict.RecipeSorter.Category.SHAPED		, "after:minecraft:shaped before:minecraft:shapeless");
        RecipeSorter.register("gregtech:shapeless"		, AdvancedCraftingShapeless.class			, net.minecraftforge.oredict.RecipeSorter.Category.SHAPELESS	, "after:minecraft:shapeless");
		// A Default Packet Handler for some of the already existing Code. Yes, all those Packets are generalised special cases in order to save on Bandwidth.
        // [        +127] = PacketConfig
        // [        +126] = PacketPrefix
        // [        +125] = PacketItemStackChat
        // [+112 to +119] = PacketBlockEvent
        // [+104 to +111] = PacketBlockError
        // [-120 to + 71] = PacketSyncData
		// [-128 to -121] = PacketSound
		NW_API = new NetworkHandler(ModIDs.GAPI, "GAPI", new PacketPrefix(), new PacketConfig(), new PacketItemStackChat()
		, new PacketBlockError							( 0), new PacketBlockError							( 1), new PacketBlockError							( 2), new PacketBlockError							( 3), new PacketBlockError							( 4), new PacketBlockError							( 5), new PacketBlockError							( 6), new PacketBlockError							( 7)
		, new PacketBlockEvent							( 0), new PacketBlockEvent							( 1), new PacketBlockEvent							( 2), new PacketBlockEvent							( 3), new PacketBlockEvent							( 4), new PacketBlockEvent							( 5), new PacketBlockEvent							( 6), new PacketBlockEvent							( 7)
		, new PacketSyncDataByte						( 0), new PacketSyncDataByte						( 1), new PacketSyncDataByte						( 2), new PacketSyncDataByte						( 3), new PacketSyncDataByte						( 4), new PacketSyncDataByte						( 5), new PacketSyncDataByte						( 6), new PacketSyncDataByte						( 7)
		, new PacketSyncDataShort						( 0), new PacketSyncDataShort						( 1), new PacketSyncDataShort						( 2), new PacketSyncDataShort						( 3), new PacketSyncDataShort						( 4), new PacketSyncDataShort						( 5), new PacketSyncDataShort						( 6), new PacketSyncDataShort						( 7)
		, new PacketSyncDataInteger						( 0), new PacketSyncDataInteger						( 1), new PacketSyncDataInteger						( 2), new PacketSyncDataInteger						( 3), new PacketSyncDataInteger						( 4), new PacketSyncDataInteger						( 5), new PacketSyncDataInteger						( 6), new PacketSyncDataInteger						( 7)
		, new PacketSyncDataLong						( 0), new PacketSyncDataLong						( 1), new PacketSyncDataLong						( 2), new PacketSyncDataLong						( 3), new PacketSyncDataLong						( 4), new PacketSyncDataLong						( 5), new PacketSyncDataLong						( 6), new PacketSyncDataLong						( 7)
		, new PacketSyncDataByteArray					( 0), new PacketSyncDataByteArray					( 1), new PacketSyncDataByteArray					( 2), new PacketSyncDataByteArray					( 3), new PacketSyncDataByteArray					( 4), new PacketSyncDataByteArray					( 5), new PacketSyncDataByteArray					( 6), new PacketSyncDataByteArray					( 7)
		, new PacketSyncDataName						( 0), new PacketSyncDataName						( 1), new PacketSyncDataName						( 2), new PacketSyncDataName						( 3), new PacketSyncDataName						( 4), new PacketSyncDataName						( 5), new PacketSyncDataName						( 6), new PacketSyncDataName						( 7)
		, new PacketSyncDataIDs							( 0), new PacketSyncDataIDs							( 1), new PacketSyncDataIDs							( 2), new PacketSyncDataIDs							( 3), new PacketSyncDataIDs							( 4), new PacketSyncDataIDs							( 5), new PacketSyncDataIDs							( 6), new PacketSyncDataIDs							( 7)
		, new PacketSyncDataByteAndIDs					( 0), new PacketSyncDataByteAndIDs					( 1), new PacketSyncDataByteAndIDs					( 2), new PacketSyncDataByteAndIDs					( 3), new PacketSyncDataByteAndIDs					( 4), new PacketSyncDataByteAndIDs					( 5), new PacketSyncDataByteAndIDs					( 6), new PacketSyncDataByteAndIDs					( 7)
		, new PacketSyncDataShortAndIDs					( 0), new PacketSyncDataShortAndIDs					( 1), new PacketSyncDataShortAndIDs					( 2), new PacketSyncDataShortAndIDs					( 3), new PacketSyncDataShortAndIDs					( 4), new PacketSyncDataShortAndIDs					( 5), new PacketSyncDataShortAndIDs					( 6), new PacketSyncDataShortAndIDs					( 7)
		, new PacketSyncDataIntegerAndIDs				( 0), new PacketSyncDataIntegerAndIDs				( 1), new PacketSyncDataIntegerAndIDs				( 2), new PacketSyncDataIntegerAndIDs				( 3), new PacketSyncDataIntegerAndIDs				( 4), new PacketSyncDataIntegerAndIDs				( 5), new PacketSyncDataIntegerAndIDs				( 6), new PacketSyncDataIntegerAndIDs				( 7)
		, new PacketSyncDataLongAndIDs					( 0), new PacketSyncDataLongAndIDs					( 1), new PacketSyncDataLongAndIDs					( 2), new PacketSyncDataLongAndIDs					( 3), new PacketSyncDataLongAndIDs					( 4), new PacketSyncDataLongAndIDs					( 5), new PacketSyncDataLongAndIDs					( 6), new PacketSyncDataLongAndIDs					( 7)
		, new PacketSyncDataByteArrayAndIDs				( 0), new PacketSyncDataByteArrayAndIDs				( 1), new PacketSyncDataByteArrayAndIDs				( 2), new PacketSyncDataByteArrayAndIDs				( 3), new PacketSyncDataByteArrayAndIDs				( 4), new PacketSyncDataByteArrayAndIDs				( 5), new PacketSyncDataByteArrayAndIDs				( 6), new PacketSyncDataByteArrayAndIDs				( 7)
		, new PacketSyncDataIDsAndCovers				( 0), new PacketSyncDataIDsAndCovers				( 1), new PacketSyncDataIDsAndCovers				( 2), new PacketSyncDataIDsAndCovers				( 3), new PacketSyncDataIDsAndCovers				( 4), new PacketSyncDataIDsAndCovers				( 5), new PacketSyncDataIDsAndCovers				( 6), new PacketSyncDataIDsAndCovers				( 7)
		, new PacketSyncDataByteAndIDsAndCovers			( 0), new PacketSyncDataByteAndIDsAndCovers			( 1), new PacketSyncDataByteAndIDsAndCovers			( 2), new PacketSyncDataByteAndIDsAndCovers			( 3), new PacketSyncDataByteAndIDsAndCovers			( 4), new PacketSyncDataByteAndIDsAndCovers			( 5), new PacketSyncDataByteAndIDsAndCovers			( 6), new PacketSyncDataByteAndIDsAndCovers			( 7)
		, new PacketSyncDataShortAndIDsAndCovers		( 0), new PacketSyncDataShortAndIDsAndCovers		( 1), new PacketSyncDataShortAndIDsAndCovers		( 2), new PacketSyncDataShortAndIDsAndCovers		( 3), new PacketSyncDataShortAndIDsAndCovers		( 4), new PacketSyncDataShortAndIDsAndCovers		( 5), new PacketSyncDataShortAndIDsAndCovers		( 6), new PacketSyncDataShortAndIDsAndCovers		( 7)
		, new PacketSyncDataIntegerAndIDsAndCovers		( 0), new PacketSyncDataIntegerAndIDsAndCovers		( 1), new PacketSyncDataIntegerAndIDsAndCovers		( 2), new PacketSyncDataIntegerAndIDsAndCovers		( 3), new PacketSyncDataIntegerAndIDsAndCovers		( 4), new PacketSyncDataIntegerAndIDsAndCovers		( 5), new PacketSyncDataIntegerAndIDsAndCovers		( 6), new PacketSyncDataIntegerAndIDsAndCovers		( 7)
		, new PacketSyncDataLongAndIDsAndCovers			( 0), new PacketSyncDataLongAndIDsAndCovers			( 1), new PacketSyncDataLongAndIDsAndCovers			( 2), new PacketSyncDataLongAndIDsAndCovers			( 3), new PacketSyncDataLongAndIDsAndCovers			( 4), new PacketSyncDataLongAndIDsAndCovers			( 5), new PacketSyncDataLongAndIDsAndCovers			( 6), new PacketSyncDataLongAndIDsAndCovers			( 7)
		, new PacketSyncDataByteArrayAndIDsAndCovers	( 0), new PacketSyncDataByteArrayAndIDsAndCovers	( 1), new PacketSyncDataByteArrayAndIDsAndCovers	( 2), new PacketSyncDataByteArrayAndIDsAndCovers	( 3), new PacketSyncDataByteArrayAndIDsAndCovers	( 4), new PacketSyncDataByteArrayAndIDsAndCovers	( 5), new PacketSyncDataByteArrayAndIDsAndCovers	( 6), new PacketSyncDataByteArrayAndIDsAndCovers	( 7)
		, new PacketSyncDataCoverVisuals				( 0), new PacketSyncDataCoverVisuals				( 1), new PacketSyncDataCoverVisuals				( 2), new PacketSyncDataCoverVisuals				( 3), new PacketSyncDataCoverVisuals				( 4), new PacketSyncDataCoverVisuals				( 5), new PacketSyncDataCoverVisuals				( 6), new PacketSyncDataCoverVisuals				( 7)
		, new PacketSyncDataByteAndCoverVisuals			( 0), new PacketSyncDataByteAndCoverVisuals			( 1), new PacketSyncDataByteAndCoverVisuals			( 2), new PacketSyncDataByteAndCoverVisuals			( 3), new PacketSyncDataByteAndCoverVisuals			( 4), new PacketSyncDataByteAndCoverVisuals			( 5), new PacketSyncDataByteAndCoverVisuals			( 6), new PacketSyncDataByteAndCoverVisuals			( 7)
		, new PacketSyncDataShortAndCoverVisuals		( 0), new PacketSyncDataShortAndCoverVisuals		( 1), new PacketSyncDataShortAndCoverVisuals		( 2), new PacketSyncDataShortAndCoverVisuals		( 3), new PacketSyncDataShortAndCoverVisuals		( 4), new PacketSyncDataShortAndCoverVisuals		( 5), new PacketSyncDataShortAndCoverVisuals		( 6), new PacketSyncDataShortAndCoverVisuals		( 7)
		, new PacketSyncDataIntegerAndCoverVisuals		( 0), new PacketSyncDataIntegerAndCoverVisuals		( 1), new PacketSyncDataIntegerAndCoverVisuals		( 2), new PacketSyncDataIntegerAndCoverVisuals		( 3), new PacketSyncDataIntegerAndCoverVisuals		( 4), new PacketSyncDataIntegerAndCoverVisuals		( 5), new PacketSyncDataIntegerAndCoverVisuals		( 6), new PacketSyncDataIntegerAndCoverVisuals		( 7)
		, new PacketSyncDataLongAndCoverVisuals			( 0), new PacketSyncDataLongAndCoverVisuals			( 1), new PacketSyncDataLongAndCoverVisuals			( 2), new PacketSyncDataLongAndCoverVisuals			( 3), new PacketSyncDataLongAndCoverVisuals			( 4), new PacketSyncDataLongAndCoverVisuals			( 5), new PacketSyncDataLongAndCoverVisuals			( 6), new PacketSyncDataLongAndCoverVisuals			( 7)
		, new PacketSyncDataByteArrayAndCoverVisuals	( 0), new PacketSyncDataByteArrayAndCoverVisuals	( 1), new PacketSyncDataByteArrayAndCoverVisuals	( 2), new PacketSyncDataByteArrayAndCoverVisuals	( 3), new PacketSyncDataByteArrayAndCoverVisuals	( 4), new PacketSyncDataByteArrayAndCoverVisuals	( 5), new PacketSyncDataByteArrayAndCoverVisuals	( 6), new PacketSyncDataByteArrayAndCoverVisuals	( 7)
		, new PacketSound								( 0), new PacketSound								( 1), new PacketSound								( 2), new PacketSound								( 3), new PacketSound								( 4), new PacketSound								( 5), new PacketSound								( 6), new PacketSound								( 7)
		);
		// some IC2 Compat.
        if (Loader.isModLoaded(ModIDs.IC2))
        OP.cell.disableItemGeneration(MT.Empty, MT.Water, MT.Lava, MT.ConstructionFoam, MT.UUMatter, MT.BioFuel);
		// Registering the TileEntity used for Meta-Generated Blocks to store the 32000 variations.
		GameRegistry.registerTileEntity(PrefixBlockTileEntity.class, "gt.MetaBlockTileEntity");
		// Creating and loading the Lang File.
    	if (CODE_CLIENT) {
    		LanguageHandler.sLangFile = new Configuration(new File(DirectoriesGT.MINECRAFT, "GregTech.lang"));
    	} else {
    		sBlockIconload.clear();
    		sBlockIconload = null;
    		sItemIconload.clear();
    		sItemIconload = null;
    	}
    	// Creating and loading the Unification Config.
    	OreDictManager.INSTANCE.mUnificationConfig = new Config("Unification.cfg");
    	// Initialising the Re-Registrations.
    	new LoaderOreDictReRegistrations().run();
    	// Register the Falling MetaBlock Entity.
        EntityRegistry.registerModEntity(PrefixBlockFallingEntity.class, "gt.MetaBlockFallingEntity", 0, this, 160, 1, T);
        // Initialise Enchantments.
		new Enchantment_WerewolfDamage();
		new Enchantment_EnderDamage();
		new Enchantment_Radioactivity();
		new Enchantment_SlimeDamage();
		// Initialises the Fluid Display Item.
		IL.Display_Fluid.set(new ItemFluidDisplay());
		// Initialises the Integrated Circuit Item.
		IL.Circuit_Selector.set(new ItemIntegratedCircuit("gt.integrated_circuit", "Selector Circuit"));
        // Register the GUI Handler.
    	NetworkRegistry.INSTANCE.registerGuiHandler(this, api_proxy);
    	// Fixing vanilla Oak Plank Slab Recipe.
    	GT_ModHandler.removeRecipe(UT.Stacks.make(Blocks.planks, 1, 0), UT.Stacks.make(Blocks.planks, 1, 1), UT.Stacks.make(Blocks.planks, 1, 2));
        GT_ModHandler.addCraftingRecipe(UT.Stacks.make(Blocks.wooden_slab, 6, 0), new Object[] {"WWW", 'W', UT.Stacks.make(Blocks.planks, 1, 0)});
		
		for (CompatBase tCompat : CompatBase.COMPAT_CLASSES) try {tCompat.onPreLoad(aEvent);} catch(Throwable e) {if (D1) e.printStackTrace(ERR);}
	}
	
	@Override
	public void onModInit2(FMLInitializationEvent aEvent) {
		OUT.println(getModNameForLog() + ": Doing a lot of the OreDictionary work (populating HashMaps for enabling faster access to Data and parsing Stuff). This will take a while. Like a LOT of time.");
		OUT.println(getModNameForLog() + ": If it seriously takes more than a hour then you definetly ran out of Memory or permgenspace, look at the other Logs to confirm it.");
		OreDictManager.INSTANCE.enableRegistrations();
		OUT.println(getModNameForLog() + ": Finished a lot of the OreDictionary work.");
        
		for (CompatBase tCompat : CompatBase.COMPAT_CLASSES) try {tCompat.onLoad(aEvent);} catch(Throwable e) {if (D1) e.printStackTrace(ERR);}
	}
	
	@Override
	public void onModPostInit2(FMLPostInitializationEvent aEvent) {
		if (Loader.isModLoaded(ModIDs.IC2)) {
			PotionsGT.ID_RADIATION = ic2.core.IC2Potion.radiation.id;
		}
		if (Loader.isModLoaded(ModIDs.ENVM)) {
			PotionsGT.ID_DEHYDRATION = EnviroPotion.dehydration.id;
			PotionsGT.ID_FROSTBITE = EnviroPotion.frostbite.id;
			PotionsGT.ID_HEATSTROKE = EnviroPotion.heatstroke.id;
			PotionsGT.ID_HYPOTHERMIA = EnviroPotion.hypothermia.id;
			PotionsGT.ID_INSANITY = EnviroPotion.insanity.id;
		}
		
		EnergyCompat.checkAvailabilities();
		
		OUT.println(getModNameForLog() + ": Doing a lot of more OreDictionary work (Registering Recipes). This will take a while. Like a LOT of time.");
		OUT.println(getModNameForLog() + ": If it seriously takes more than a hour then you definetly ran out of Memory or permgenspace, look at the other Logs to confirm it.");
		OreDictManager.INSTANCE.onPostLoad();
		OUT.println(getModNameForLog() + ": Finished another batch of the OreDictionary work.");
        
		OreDictPrefix.applyAllStackSizes();
		
		// Saving the Lang File.
		LanguageHandler.save();
        
        if (mPlayerLogger != null) new Thread(mPlayerLogger).start();
        
		for (CompatBase tCompat : CompatBase.COMPAT_CLASSES) try {tCompat.onPostLoad(aEvent);} catch(Throwable e) {if (D1) e.printStackTrace(ERR);}
		
		OUT.println(getModNameForLog() + ": Dumping Material List for the Config Folder");
        for (OreDictMaterial tMaterial : OreDictMaterial.MATERIAL_ARRAY) if (tMaterial != null && !tMaterial.contains(TD.Properties.INVALID_MATERIAL)) MAT_LOG.println(tMaterial.mNameInternal);
	}
	
	@Override
	public void onModServerStarting2(FMLServerStartingEvent aEvent) {
		for (CompatBase tCompat : CompatBase.COMPAT_CLASSES) try {tCompat.onServerStarting(aEvent);} catch(Throwable e) {if (D1) e.printStackTrace(ERR);}
	}
	
	@Override
	public void onModServerStarted2(FMLServerStartedEvent aEvent) {
		for (Map tMap : STACKMAPS) UT.Code.reMap(tMap);
        OUT.println(getModNameForLog() + ": Re-Unificating Recipes.");
//    	UT.Fluids.reInit();
    	Recipe.reInit();
		
    	OUT.println(getModNameForLog() + ": Unificating outputs of all known Recipe Types.");
    	HashSetNoNulls<ItemStack> tStacks = new HashSetNoNulls<ItemStack>(10000);
    	
    	try {
    	OUT.println(getModNameForLog() + ": IC2 Machines");
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.cannerBottle				.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.centrifuge				.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.compressor				.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.extractor					.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.macerator					.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.metalformerCutting		.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.metalformerExtruding		.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.metalformerRolling		.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.matterAmplifier			.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.oreWashing				.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	} catch(Throwable e) {/**/}
    	
    	OUT.println(getModNameForLog() + ": Dungeon Loot");
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.DUNGEON_CHEST			).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.BONUS_CHEST				).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.VILLAGE_BLACKSMITH		).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.STRONGHOLD_CROSSING		).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.STRONGHOLD_LIBRARY		).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.STRONGHOLD_CORRIDOR		).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.PYRAMID_JUNGLE_DISPENSER	).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.PYRAMID_JUNGLE_CHEST		).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.PYRAMID_DESERT_CHEST		).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.MINESHAFT_CORRIDOR		).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	OUT.println(getModNameForLog() + ": Smelting");
    	for (Object tStack : FurnaceRecipes.smelting().getSmeltingList().values()) tStacks.add((ItemStack)tStack);
    	OUT.println(getModNameForLog() + ": Crafting Recipes");
        for (Object tRecipe : CraftingManager.getInstance().getRecipeList()) if (tRecipe instanceof IRecipe) tStacks.add(((IRecipe)tRecipe).getRecipeOutput());
	    
	    for (ItemStack tOutput : tStacks) {
	    	if (OreDictManager.INSTANCE.isOreDictItem(tOutput)) {
	    		FMLLog.severe("GT-ERR-01: @ " + tOutput.getUnlocalizedName() + "   " + tOutput.getDisplayName());
	    		if (CS.CODE_CLIENT) {
		    		FMLLog.severe("A Recipe used an OreDict Item as Output directly, without copying it before!!! This is a typical CallByReference/CallByValue Error");
		    		FMLLog.severe("Said Item will be renamed to make the invalid Recipe visible, so that you can report it properly.");
		    		FMLLog.severe("Please check all Recipes outputting this Item, and report the Recipes to their Owner.");
		    		FMLLog.severe("The Owner of the ==>RECIPE<==, NOT the Owner of the Item, which has been mentioned above!!!");
		    		FMLLog.severe("And ONLY Recipes which are ==>OUTPUTTING<== the Item, sorry but I don't want failed Bug Reports.");
		    		FMLLog.severe("GregTech just reports this Error to you, so you can report it to the Mod causing the Problem.");
		    		FMLLog.severe("Even though I make that Bug visible, I can not and will not fix that for you, that's for the causing Mod to fix.");
		    		FMLLog.severe("And speaking of failed Reports:");
		    		FMLLog.severe("Both IC2 and GregTech CANNOT be the CAUSE of this Problem, so don't report it to either of them.");
		    		FMLLog.severe("I REPEAT, BOTH, IC2 and GregTech CANNOT be the source of THIS BUG. NO MATTER WHAT.");
		    		FMLLog.severe("Asking in the IC2 Forums, which Mod is causing that, won't help anyone, since it is not possible to determine, which Mod it is.");
		    		FMLLog.severe("If it would be possible, then I would have had added the Mod which is causing it to the Message already. But it is not possible.");
		    		FMLLog.severe("Sorry, but this Error is serious enough to justify this Wall-O-Text and the partially allcapsed Language.");
		    		FMLLog.severe("Also it is a Ban Reason on the IC2-Forums to seriously post this Text. We all know about its existence.");
		    		
		    		tOutput.setStackDisplayName("ERROR!");
		    		UT.NBT.setBoolean(UT.NBT.getNBT(tOutput), "gt.err.oredict.output", T);
	    		}
	    	} else {
		    	OM.set(tOutput);
	    	}
	    }
	    
        OUT.println(getModNameForLog() + ": Cleaning up all OreDict Crafting Recipes, which have an empty List in them, since they are never meeting any Condition.");
        List tList = CraftingManager.getInstance().getRecipeList();
        for (int i = 0; i < tList.size(); i++) {
        	Object tRecipe = tList.get(i);
        	if (tRecipe instanceof ShapedOreRecipe) {
        		Object[] tInput = ((ShapedOreRecipe)tRecipe).getInput();
        		for (int j = 0; j < tInput.length; j++) {
        			if (tInput[j] instanceof List && ((List)tInput[j]).isEmpty()) {
//        				DEB.println("Removed Recipe for " + ((ShapedOreRecipe)tRecipe).getRecipeOutput().getDisplayName() + " because Ingredient Nr. " + j + " is missing");
        				tList.remove(i--);
        				break;
        			}
        		}
        	} else if (tRecipe instanceof ShapelessOreRecipe) {
        		ArrayList<Object> tInput = ((ShapelessOreRecipe)tRecipe).getInput();
        		for (int j = 0; j < tInput.size(); j++) {
        			if (tInput.get(j) instanceof List && ((List)tInput.get(j)).isEmpty()) {
//        				DEB.println("Removed Recipe for " + ((ShapelessOreRecipe)tRecipe).getRecipeOutput().getDisplayName() + " because Ingredient Nr. " + j + " is missing");
        				tList.remove(i--);
        				break;
        			}
        		}
        	}
        }
        
		for (CompatBase tCompat : CompatBase.COMPAT_CLASSES) try {tCompat.onServerStarted(aEvent);} catch(Throwable e) {if (D1) e.printStackTrace(ERR);}
	}
	
	@Override
	public void onModServerStopping2(FMLServerStoppingEvent aEvent) {
		for (CompatBase tCompat : CompatBase.COMPAT_CLASSES) try {tCompat.onServerStopping(aEvent);} catch(Throwable e) {if (D1) e.printStackTrace(ERR);}
	}
	
	@Override
	public void onModServerStopped2(FMLServerStoppedEvent aEvent) {
		for (CompatBase tCompat : CompatBase.COMPAT_CLASSES) try {tCompat.onServerStopped(aEvent);} catch(Throwable e) {if (D1) e.printStackTrace(ERR);}
	}
}