package gregapi.block.metatype;

import static gregapi.data.CS.*;
import gregapi.block.IBlockToolable;
import gregapi.data.IL;
import gregapi.data.LH;
import gregapi.data.MT;
import gregapi.data.OP;
import gregapi.oredict.IOreDictListenerEvent;
import gregapi.oredict.OreDictItemData;
import gregapi.oredict.OreDictMaterial;
import gregapi.recipes.GT_ModHandler;
import gregapi.recipes.GT_ModHandler.RecipeBits;
import gregapi.recipes.Recipe.RecipeMap;
import gregapi.render.IIconContainer;
import gregapi.util.OM;
import gregapi.util.UT;

import java.util.List;
import java.util.Random;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.entity.Entity;
import net.minecraft.init.Blocks;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.common.util.ForgeDirection;

public class BlockStones extends BlockMetaType implements IOreDictListenerEvent, IBlockToolable {
	public static final boolean[] MOSSY = {F,F,T,F,F,T,F,F,F,F,F,F,F,F,F,F};
	
	public BlockStones(Class<? extends ItemBlock> aItemClass, Material aVanillaMaterial, SoundType aVanillaSoundType, String aName, String aDefaultLocalised, OreDictMaterial aMaterial, float aResistanceMultiplier, float aHardnessMultiplier, int aHarvestLevel, IIconContainer[] aIcons) {
		super(aItemClass, aVanillaMaterial, aVanillaSoundType, aName, aDefaultLocalised, aMaterial, aResistanceMultiplier, aHardnessMultiplier, aHarvestLevel, 9, aIcons);
		if (aDefaultLocalised != null) {
			LH.add(getUnlocalizedName()+".0.name", aDefaultLocalised);
			LH.add(getUnlocalizedName()+".1.name", aDefaultLocalised+" Cobblestone");
			LH.add(getUnlocalizedName()+".2.name", "Mossy "+aDefaultLocalised+" Cobblestone");
			LH.add(getUnlocalizedName()+".3.name", aDefaultLocalised+" Bricks");
			LH.add(getUnlocalizedName()+".4.name", "Cracked "+aDefaultLocalised+" Bricks");
			LH.add(getUnlocalizedName()+".5.name", "Mossy "+aDefaultLocalised+" Bricks");
			LH.add(getUnlocalizedName()+".6.name", "Chiseled "+aDefaultLocalised);
			LH.add(getUnlocalizedName()+".7.name", "Smooth "+aDefaultLocalised);
			LH.add(getUnlocalizedName()+".8.name", "Reinforced "+aDefaultLocalised+" Bricks");
			LH.add(getUnlocalizedName()+".9.name", "Redstoned "+aDefaultLocalised+" Bricks");
		}
		if (aMaterial == null) {
			OM.data(UT.Stacks.make(this, 1, 8), new OreDictItemData(MT.Stone, U, MT.Steel, OP.stick.mAmount));
			OM.data(UT.Stacks.make(this, 1, 9), new OreDictItemData(MT.Stone, U, MT.Redstone, OP.dust.mAmount));
		} else {
			OM.data(UT.Stacks.make(this, 1, 8), new OreDictItemData(aMaterial, U, MT.Steel, OP.stick.mAmount));
			OM.data(UT.Stacks.make(this, 1, 9), new OreDictItemData(aMaterial, U, MT.Redstone, OP.dust.mAmount));
			OM.reg_(OP.stone, aMaterial, UT.Stacks.make(this, 1, 0));
			OM.reg_(OP.stone, aMaterial, UT.Stacks.make(this, 1, 1));
			OM.reg_(OP.stone, aMaterial, UT.Stacks.make(this, 1, 2));
			OM.reg_(OP.stone, aMaterial, UT.Stacks.make(this, 1, 3));
			OM.reg_(OP.stone, aMaterial, UT.Stacks.make(this, 1, 4));
			OM.reg_(OP.stone, aMaterial, UT.Stacks.make(this, 1, 5));
			OM.reg_(OP.stone, aMaterial, UT.Stacks.make(this, 1, 6));
			OM.reg_(OP.stone, aMaterial, UT.Stacks.make(this, 1, 7));
		}
		OP.crafting.addListener(this);
		GT_ModHandler.addSmeltingRecipe(UT.Stacks.make(this, 1, 0), UT.Stacks.make(this, 1, 7));
		GT_ModHandler.addSmeltingRecipe(UT.Stacks.make(this, 1, 1), UT.Stacks.make(this, 1, 0));
		GT_ModHandler.addSmeltingRecipe(UT.Stacks.make(this, 1, 2), UT.Stacks.make(this, 1, 0));
		GT_ModHandler.addSmeltingRecipe(UT.Stacks.make(this, 1, 3), UT.Stacks.make(this, 1, 0));
		GT_ModHandler.addSmeltingRecipe(UT.Stacks.make(this, 1, 4), UT.Stacks.make(this, 1, 0));
		GT_ModHandler.addSmeltingRecipe(UT.Stacks.make(this, 1, 5), UT.Stacks.make(this, 1, 0));
		GT_ModHandler.addSmeltingRecipe(UT.Stacks.make(this, 1, 6), UT.Stacks.make(this, 1, 0));
		GT_ModHandler.addSmeltingRecipe(UT.Stacks.make(this, 1, 7), UT.Stacks.make(this, 1, 0));
		
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1, 6), RecipeBits.DEFAULT, new Object[] {"y", "X", 'X', UT.Stacks.make(this, 1, 7)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1, 4), RecipeBits.DEFAULT, new Object[] {"h", "X", 'X', UT.Stacks.make(this, 1, 3)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1, 1), RecipeBits.DEFAULT, new Object[] {"h", "X", 'X', UT.Stacks.make(this, 1, 0)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 4, 3), RecipeBits.DEFAULT, new Object[] {"XX", "XX", 'X', UT.Stacks.make(this, 4, 0)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 4, 3), RecipeBits.DEFAULT, new Object[] {"XX", "XX", 'X', UT.Stacks.make(this, 4, 7)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1, 8), RecipeBits.DEFAULT, new Object[] {"Sh", "X ", 'X', UT.Stacks.make(this, 1, 3), 'S', OP.stick.dat(MT.TECH.AnyIronSteel)});
		GT_ModHandler.addCraftingRecipe(UT.Stacks.make(this, 1, 9), RecipeBits.DEFAULT, new Object[] {"Dh", "X ", 'X', UT.Stacks.make(this, 1, 3), 'D', OP.dust.dat(MT.Redstone)});
		
		RecipeMap.sAssemblerRecipes		.addRecipe2(T, 16,					  16, UT.Stacks.make(this, 1, 0), IL.Circuit_Selector.getWithMeta(0, 4), UT.Stacks.make(this, 1, 3));
		RecipeMap.sHammerRecipes		.addRecipe1(T, 16,					  16, UT.Stacks.make(this, 1, 0), UT.Stacks.make(this, 1, 1));
		RecipeMap.sHammerRecipes		.addRecipe1(T, 16,					  16, UT.Stacks.make(this, 1, 3), UT.Stacks.make(this, 1, 4));
		RecipeMap.sCrusherRecipes		.addRecipe1(T, 16,  25+aHarvestLevel* 25, UT.Stacks.make(this, 1, 0), UT.Stacks.make(this, 1, 1));
		RecipeMap.sCrusherRecipes		.addRecipe1(T, 16,  50+aHarvestLevel* 50, UT.Stacks.make(this, 1, 3), UT.Stacks.make(this, 1, 4));
		RecipeMap.sCrusherRecipes		.addRecipe1(T, 16,  50+aHarvestLevel* 50, UT.Stacks.make(this, 1, 4), UT.Stacks.make(this, 1, 1));
		RecipeMap.sCrusherRecipes		.addRecipe1(T, 16,  50+aHarvestLevel* 50, UT.Stacks.make(this, 1, 5), UT.Stacks.make(this, 1, 1));
		RecipeMap.sCrusherRecipes		.addRecipe1(T, 16,  50+aHarvestLevel* 50, UT.Stacks.make(this, 1, 6), UT.Stacks.make(this, 1, 1));
		RecipeMap.sCrusherRecipes		.addRecipe1(T, 16,  50+aHarvestLevel* 50, UT.Stacks.make(this, 1, 7), UT.Stacks.make(this, 1, 1));
		RecipeMap.sCrusherRecipes		.addRecipe1(T, 16, 200+aHarvestLevel*200, UT.Stacks.make(this, 1, 8), UT.Stacks.make(this, 1, 1), OM.dust(MT.Fe, OP.stick.mAmount));
		RecipeMap.sCrusherRecipes		.addRecipe1(T, 16,  50+aHarvestLevel* 50, UT.Stacks.make(this, 1, 9), UT.Stacks.make(this, 1, 4), OM.dust(MT.Redstone));
	}
	
	@Override
	protected BlockMetaType makeSlab(Class<? extends ItemBlock> aItemClass, Material aVanillaMaterial, SoundType aVanillaSoundType, String aName, String aDefaultLocalised, OreDictMaterial aMaterial, float aResistanceMultiplier, float aHardnessMultiplier, int aHarvestLevel, int aCount, IIconContainer[] aIcons, byte aSlabType, BlockMetaType aBlock) {
		return new BlockStones(aItemClass, aVanillaMaterial, aVanillaSoundType, aName, aDefaultLocalised, aMaterial, aResistanceMultiplier, aHardnessMultiplier, aHarvestLevel, aCount, aIcons, aSlabType, aBlock);
	}
	
	protected BlockStones(Class<? extends ItemBlock> aItemClass, Material aVanillaMaterial, SoundType aVanillaSoundType, String aName, String aDefaultLocalised, OreDictMaterial aMaterial, float aResistanceMultiplier, float aHardnessMultiplier, int aHarvestLevel, int aCount, IIconContainer[] aIcons, byte aSlabType, BlockMetaType aBlock) {
		super(aItemClass, aVanillaMaterial, aVanillaSoundType, aName, aDefaultLocalised, aMaterial, aResistanceMultiplier, aHardnessMultiplier, aHarvestLevel, aCount, aIcons, aSlabType, aBlock);
		if (aDefaultLocalised != null) {
			LH.add(getUnlocalizedName()+".0.name", aDefaultLocalised+" Slab");
			LH.add(getUnlocalizedName()+".1.name", aDefaultLocalised+" Cobblestone Slab");
			LH.add(getUnlocalizedName()+".2.name", "Mossy "+aDefaultLocalised+" Cobblestone Slab");
			LH.add(getUnlocalizedName()+".3.name", aDefaultLocalised+" Bricks Slab");
			LH.add(getUnlocalizedName()+".4.name", "Cracked "+aDefaultLocalised+" Bricks Slab");
			LH.add(getUnlocalizedName()+".5.name", "Mossy "+aDefaultLocalised+" Bricks Slab");
			LH.add(getUnlocalizedName()+".6.name", "Chiseled "+aDefaultLocalised+" Slab");
			LH.add(getUnlocalizedName()+".7.name", "Smooth "+aDefaultLocalised+" Slab");
			LH.add(getUnlocalizedName()+".8.name", "Reinforced "+aDefaultLocalised+" Bricks Slab");
			LH.add(getUnlocalizedName()+".9.name", "Redstoned "+aDefaultLocalised+" Bricks Slab");
		}
		if (aMaterial == null) aMaterial = MT.Stone;
		OM.data(UT.Stacks.make(this, 1, 0), new OreDictItemData(aMaterial, U / 2));
		OM.data(UT.Stacks.make(this, 1, 1), new OreDictItemData(aMaterial, U / 2));
		OM.data(UT.Stacks.make(this, 1, 2), new OreDictItemData(aMaterial, U / 2));
		OM.data(UT.Stacks.make(this, 1, 3), new OreDictItemData(aMaterial, U / 2));
		OM.data(UT.Stacks.make(this, 1, 4), new OreDictItemData(aMaterial, U / 2));
		OM.data(UT.Stacks.make(this, 1, 5), new OreDictItemData(aMaterial, U / 2));
		OM.data(UT.Stacks.make(this, 1, 6), new OreDictItemData(aMaterial, U / 2));
		OM.data(UT.Stacks.make(this, 1, 7), new OreDictItemData(aMaterial, U / 2));
		OM.data(UT.Stacks.make(this, 1, 8), new OreDictItemData(aMaterial, U / 2, MT.Steel, OP.stick.mAmount / 2));
		OM.data(UT.Stacks.make(this, 1, 9), new OreDictItemData(aMaterial, U / 2, MT.Redstone, OP.dust.mAmount / 2));
		OM.data(UT.Stacks.make(this, 1,10), new OreDictItemData(aMaterial, U / 2));
		OM.data(UT.Stacks.make(this, 1,11), new OreDictItemData(aMaterial, U / 2));
		OM.data(UT.Stacks.make(this, 1,12), new OreDictItemData(aMaterial, U / 2));
		OM.data(UT.Stacks.make(this, 1,13), new OreDictItemData(aMaterial, U / 2));
		OM.data(UT.Stacks.make(this, 1,14), new OreDictItemData(aMaterial, U / 2));
		OM.data(UT.Stacks.make(this, 1,15), new OreDictItemData(aMaterial, U / 2));
	}
	
	@Override
	public void onOreRegistration(OreDictRegistrationContainer aEvent) {
		if (aEvent.mOreDictName.equals(DYE_OREDICTS_LENSE[DYE_INDEX_White])) {
			RecipeMap.sLaserEngraverRecipes.addRecipe2(T, 16, 64, UT.Stacks.make(this, 1, 7), UT.Stacks.amount(0, aEvent.mStack), UT.Stacks.make(this, 1, 6));
		}
	}
	
	@Override
	public int getItemStackLimit(ItemStack aStack) {
		switch (UT.Stacks.meta(aStack)) {
		case  1: return UT.Code.bindStack(OP.stoneCobble		.mDefaultStackSize * (mBlock.mBlock == mBlock ? 1 : 2));
		case  2: return UT.Code.bindStack(OP.stoneMossy			.mDefaultStackSize * (mBlock.mBlock == mBlock ? 1 : 2));
		case  3: return UT.Code.bindStack(OP.stoneBricks		.mDefaultStackSize * (mBlock.mBlock == mBlock ? 1 : 2));
		case  4: return UT.Code.bindStack(OP.stoneCracked		.mDefaultStackSize * (mBlock.mBlock == mBlock ? 1 : 2));
		case  5: return UT.Code.bindStack(OP.stoneMossyBricks	.mDefaultStackSize * (mBlock.mBlock == mBlock ? 1 : 2));
		case  6: return UT.Code.bindStack(OP.stoneChiseled		.mDefaultStackSize * (mBlock.mBlock == mBlock ? 1 : 2));
		case  7: return UT.Code.bindStack(OP.stonePolished		.mDefaultStackSize * (mBlock.mBlock == mBlock ? 1 : 2));
		case  8: return UT.Code.bindStack(OP.stoneBricks		.mDefaultStackSize * (mBlock.mBlock == mBlock ? 1 : 2));
		case  9: return UT.Code.bindStack(OP.stoneBricks		.mDefaultStackSize * (mBlock.mBlock == mBlock ? 1 : 2));
		default: return UT.Code.bindStack(OP.stone				.mDefaultStackSize * (mBlock.mBlock == mBlock ? 1 : 2));
		}
	}
	
	@Override
	public long onToolClick(String aTool, long aRemainingDurability, long aQuality, Entity aPlayer, List<String> aChatReturn, IInventory aPlayerInventory, boolean aSneaking, ItemStack aStack, World aWorld, byte aSide, int aX, int aY, int aZ, float aHitX, float aHitY, float aHitZ) {
		if (aTool.equals(TOOL_chisel)) {
			byte aMetaData = (byte)aWorld.getBlockMetadata(aX, aY, aZ);
			if (aMetaData == 7) {
				aWorld.setBlockMetadataWithNotify(aX, aY, aZ, 6, 3);
				return mBlock == this ? 10000 : 5000;
			}
		}
		if (aTool.equals(TOOL_file)) {
			byte aMetaData = (byte)aWorld.getBlockMetadata(aX, aY, aZ);
			if (aMetaData == 0) {
				aWorld.setBlockMetadataWithNotify(aX, aY, aZ, 7, 3);
				return mBlock == this ? 10000 : 5000;
			}
		}
		return 0;
	}
	
	@Override
	public float getBlockHardness(World aWorld, int aX, int aY, int aZ) {
		switch(aWorld.getBlockMetadata(aX, aY, aZ)) {
		case  8: return Blocks.stone.getBlockHardness(aWorld, aX, aY, aZ) * mHardnessMultiplier * 2;
		default: return Blocks.stone.getBlockHardness(aWorld, aX, aY, aZ) * mHardnessMultiplier;
		}
	}
	
	@Override
	public float getExplosionResistance(int aMeta) {
		switch(aMeta) {
		case  8: return Blocks.stone.getExplosionResistance(null) * mResistanceMultiplier * 2;
		default: return Blocks.stone.getExplosionResistance(null) * mResistanceMultiplier;
		}
	}
	
    @Override
    public void updateTick(World aWorld, int aX, int aY, int aZ, Random aRandom) {
    	if (!aWorld.isRemote && UT.Worlds.getCoordsOnFire(aWorld, aX, aY, aZ)) switch(aWorld.getBlockMetadata(aX, aY, aZ)) {
    	case  2: aWorld.setBlock(aX, aY, aZ, this, 1, 3); break;
    	case  5: aWorld.setBlock(aX, aY, aZ, this, 3, 3); break;
    	}
    }
    
	@Override public int isProvidingWeakPower(IBlockAccess aWorld, int aX, int aY, int aZ, int aSide) {return aWorld.getBlockMetadata(aX, aY, aZ) == 9 ? 15 : 0;}
	@Override public boolean shouldCheckWeakPower(IBlockAccess aWorld, int aX, int aY, int aZ, int aSide) {return aWorld.getBlockMetadata(aX, aY, aZ) != 9;}
	@Override public void onNeighborBlockChange(World aWorld, int aX, int aY, int aZ, Block aBlock) {if (MOSSY[UT.Code.bind4(aWorld.getBlockMetadata(aX, aY, aZ))] && UT.Worlds.getCoordsOnFire(aWorld, aX, aY, aZ)) aWorld.scheduleBlockUpdate(aX, aY, aZ, this, tickRate(aWorld));}
    @Override public void onBlockAdded(World aWorld, int aX, int aY, int aZ) {if (MOSSY[UT.Code.bind4(aWorld.getBlockMetadata(aX, aY, aZ))] && UT.Worlds.getCoordsOnFire(aWorld, aX, aY, aZ)) aWorld.scheduleBlockUpdate(aX, aY, aZ, this, tickRate(aWorld));}
	@Override public int tickRate(World aWorld) {return 100;}
	@Override public int damageDropped(int aMeta) {return aMeta==0?1:aMeta;}
	@Override public boolean canCreatureSpawn(int aMeta) {return mBlock == this && aMeta < 3;}
	@Override public int getFlammability(IBlockAccess aWorld, int aX, int aY, int aZ, ForgeDirection aSide) {return 0;}
	@Override public boolean isFlammable(IBlockAccess aWorld, int aX, int aY, int aZ, ForgeDirection aSide) {return MOSSY[UT.Code.bind4(aWorld.getBlockMetadata(aX, aY, aZ))];}
	@Override public int getFireSpreadSpeed(IBlockAccess aWorld, int aX, int aY, int aZ, ForgeDirection aSide) {return MOSSY[UT.Code.bind4(aWorld.getBlockMetadata(aX, aY, aZ))]?3000:0;}
	@Override public boolean isFireSource(World aWorld, int aX, int aY, int aZ, ForgeDirection aSide) {return MOSSY[UT.Code.bind4(aWorld.getBlockMetadata(aX, aY, aZ))];}
}